Create comment
Creates a comment on a page, block, or existing discussion thread.
parent object with a page_id or block_id in the body params. For example, this request creates a comment attached to a block:
discussion_id string in the body params.
parent.block_id. It does not support creating a new discussion anchored to a selected range of text inside a block. To reply to an existing selected-text discussion, use discussion_id.parent.page_id, parent.block_id, or discussion_id must be provided.
Comment body format
The comment body can be provided in one of two formats:rich_text: An array of rich text objects that represent the content of the comment.markdown: A Markdown string. Comment Markdown supports inline formatting only (bold, italic, strikethrough, inline code, links), inline equations, and mentions. Block-level Markdown such as fenced code blocks, headings, lists, tables, and blockquotes does not render as structured blocks in comments.
rich_text or markdown must be provided. Providing both or neither will return a validation error.
With markdown, set markdown_version: "v2" to write Notion-flavored Markdown instead of enhanced markdown. v2 is recommended. v1 is deprecated. It’s the default on current Notion-Versions. Sending markdown_version with rich_text returns a 400 validation_error. See Markdown versions.
To see additional examples of creating a page, inline, or discussion comment and to learn more about comments in Notion, see the Working with comments guide.
Errors
Each Public API endpoint can return several possible error codes. See the Error codes section of the Status codes documentation for more information.Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Headers
The API version to use for this request. The latest version is 2026-03-11.
2026-03-11 Body
- Option 1
- Option 2
- Option 3
- Option 4
The parent of the comment. This can be a page or a block.
- Option 1
- Option 2
An array of rich text objects that represent the content of the comment.
100- Text
- Mention
- Equation
An array of files to attach to the comment. Maximum of 3 allowed.
3Display name for the comment.
- Integration
- User
- Custom
The Markdown syntax to use. v2 is Notion-flavored Markdown and is recommended. v1 is enhanced markdown. It's deprecated. It's the default on current Notion-Versions. The next Notion-Version rejects v1 with a 400 validation_error.
v1, v2